/***************************************************************************
                          dbhandling.h  -  description                              
                             -------------------                                         
    begin                : Tue Jun 8 1999                                           
    copyright            : (C) 1999 by Edwin Schepers                         
    email                : zeus@castel.nl                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DBHANDLING_H
#define DBHANDLING_H

#include <qstring.h>
#include <qdialog.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qmessagebox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qlineedit.h>
#include <qlist.h>
#include <qlistview.h>

#include "general.h"

/**
  *@author Edwin Schepers
  */

enum searchType { Filename, Artist, Title, Album, Year, cdname};

class DBentry {

 public:
 DBentry(char *loc);
 char where[100];
 QString filename;
 QString artist;
 QString title;
 QString album;
 char year[4+1];
};



class DBhandling {

 public:
	DBhandling();
	~DBhandling();
  void find(char *str, bool cs, searchType);
  QList<DBentry> *dbentrieslist;
  void deleteFromDB(DBentry *item);
  void clearList(void);
 private:
  DBentry *getEntry(char *line);
  int listAvailable;
};

#endif






































